/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 27);
/******/ })
/************************************************************************/
/******/ ({

/***/ 0:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = version;
/* eslint-env webextensions */

function version() {
    return new Promise(function (resolve, reject) {
        chrome.storage.local.get('version', function (items) {
            var contractVersion = 21;
            if (items.version) contractVersion = items.version;
            resolve(contractVersion > 25 ? 3 : 2);
        });
    });
}

/***/ }),

/***/ 27:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _version = __webpack_require__(0);

var _version2 = _interopRequireDefault(_version);

var _autofill = __webpack_require__(28);

var _autofill2 = _interopRequireDefault(_autofill);

var _autofill3 = __webpack_require__(29);

var _autofill4 = _interopRequireDefault(_autofill3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _version2.default)().then(function (v) {
    if (v === 2) new _autofill2.default();else new _autofill4.default();
}); /* eslint-env webextensions */

/***/ }),

/***/ 28:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/* eslint-env webextensions */

var KeyHubFill = function KeyHubFill() {
    var _this = this;

    _classCallCheck(this, KeyHubFill);

    this.register = function () {
        _this._observer = new MutationObserver(function (mutations) {
            _this.findAndMarkLoginForms();
        });
        _this._observer.observe(document, { childList: true, attributes: true, subtree: true });
        window.addEventListener('scroll', _this.findAndMarkLoginForms, { capture: true, passive: true });
        window.addEventListener('resize', _this.findAndMarkLoginForms);
        _this.findAndMarkLoginForms();
    };

    this.clearDOMObserver = function () {
        if (_this._observer !== undefined) {
            _this._observer.takeRecords();
        }
    };

    this.resizeIFrame = function (height) {
        _this._contextPopup.iframe.style.height = Math.min(400, height) + 'px';
        _this.clearDOMObserver();
    };

    this.closeIFrame = function (event) {
        if (_this._contextPopup !== undefined) {
            _this._contextPopup.iframe.remove();
            _this._contextPopup = undefined;
        }
    };

    this.fill = function (creds) {
        if (_this._contextPopup !== undefined) {
            var formToFill = _this._contextPopup.form;
            var prio = _this._contextPopup.prio;
            if (creds.type === 'TOTP') {
                if (creds.password !== undefined) {
                    formToFill.usn.filter(function (e, i) {
                        return i === 0;
                    }).forEach(function (e) {
                        return _this.fillInput(e, creds.password);
                    });
                }
            } else {
                if (creds.username !== undefined) {
                    if (formToFill.usn.length === 1 && (!formToFill.usn[0].value || formToFill.usn[0] === prio)) {
                        _this.fillInput(formToFill.usn[0], creds.username);
                    } else if (formToFill.usn.length > 1 && formToFill.usn[0] === prio) {
                        _this.fillInput(formToFill.usn[0], creds.username);
                    }
                }
                if (creds.password !== undefined) {
                    formToFill.pwd.filter(function (e, i) {
                        return i === 0;
                    }).forEach(function (e) {
                        return _this.fillInput(e, creds.password);
                    });
                }
            }
        }
        _this.closeIFrame();
    };

    this.fillInput = function (input, value) {
        input.value = value;
        input.dispatchEvent(new Event('change', { bubbles: true }));
        input.dispatchEvent(new Event('input', { bubbles: true }));
        input.dispatchEvent(new KeyboardEvent('keydown', { bubbles: true }));
        input.dispatchEvent(new KeyboardEvent('keyup', { bubbles: true }));
    };

    this.findLoginForms = function () {
        return Array.prototype.slice.call(document.querySelectorAll('form')).map(_this.scoreForm).filter(function (form) {
            return form.usn.length > 0 || form.pwd.length > 0;
        }).sort(function (a, b) {
            return b.score - a.score;
        });
    };

    this.findAndMarkLoginForms = function () {
        var forms = _this.findLoginForms().reduce(function (acc, val) {
            if (acc.length === 0 || val.score >= 4 || val.score === acc[0].score) {
                acc.push(val);
            }
            return acc;
        }, []);
        _this._markers.forEach(function (marker) {
            return marker.dead = true;
        });
        forms.filter(function (form) {
            return form.score > 2;
        }).forEach(function (form) {
            form.usn.forEach(function (input) {
                return _this.markInput(form, input);
            });
            form.pwd.forEach(function (input) {
                return _this.markInput(form, input);
            });
        });
        if (_this._contextPopup !== undefined && _this._contextPopup.prio !== undefined) {
            var bounds = _this._contextPopup.prio.getBoundingClientRect();
            _this.positionPopup(_this._contextPopup.iframe, bounds);
        }
        _this.removeAllDeadMarkers();
        _this.clearDOMObserver();
    };

    this.removeAllDeadMarkers = function () {
        _this._markers.filter(function (marker) {
            return marker.dead;
        }).forEach(function (marker) {
            return marker.marker.remove();
        });
        _this._markers = _this._markers.filter(function (marker) {
            return !marker.dead;
        });
    };

    this.scoreForm = function (form) {
        var USERNAME = ['input[type=email]', 'input[type=text]', 'input:not([type])'].join(',');
        var PASSWORD = 'input:not([autocomplete=new-password])[type=password]';
        var usernameFields = Array.prototype.slice.call(form.querySelectorAll(USERNAME)).filter(_this.isVisible);
        var passwordFields = Array.prototype.slice.call(form.querySelectorAll(PASSWORD)).filter(_this.isVisible);
        var ret = {
            form: form,
            usn: usernameFields,
            pwd: passwordFields
        };

        if (passwordFields.length === 0 && usernameFields.length === 0) {
            ret.score = 0;
        } else if (usernameFields.some(function (usn) {
            return usn.getAttribute('autocomplete') === 'username';
        }) || passwordFields.some(function (pwd) {
            return pwd.getAttribute('autocomplete') === 'current-password';
        })) {
            ret.score = 5;
        } else if (passwordFields.length === 1 && usernameFields.length === 1) {
            ret.score = 4;
        } else if (passwordFields.length === 1 && usernameFields.length === 0) {
            ret.score = 3;
        } else if (passwordFields.length === 1 && usernameFields.length > 1) {
            ret.score = 2;
        } else if (passwordFields.length === 0 && usernameFields.length === 1) {
            ret.score = 1;
        } else {
            ret.score = 0;
        }
        return ret;
    };

    this.isVisible = function (elem) {
        return !!(elem.offsetWidth || elem.offsetHeight || elem.getClientRects().length);
    };

    this.markInput = function (form, input) {
        var markerObj = _this._markers.find(function (m) {
            return m.input === input;
        });
        if (markerObj === undefined) {
            markerObj = {
                form: form,
                input: input,
                marker: document.createElement('div')
            };
            document.body.appendChild(markerObj.marker);
            markerObj.marker.addEventListener('click', function (event) {
                event.stopPropagation();
                _this.showContextPopup(form, input, input.getBoundingClientRect());
            });
            _this._markers.push(markerObj);
        }
        var marker = markerObj.marker;
        var bounds = input.getBoundingClientRect();
        marker.dataset.keyhubmarker = 'true';
        marker.dataset.anchor = input.name;
        marker.style.backgroundImage = 'url(data:image/png;base64,' + 'iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAYAAABzenr0AAAABmJLR0QA/wD/AP+gvaeTAAAACXBI' + 'WXMAAAsTAAALEwEAmpwYAAAAB3RJTUUH4QUeDCAaCBbp5wAAAlNJREFUWMPFlr2LE0EYh5/ZiIUW' + '4lcjVwtXSbhCMKBkTiutRETB5kYGQTj/Av8Bue4QFAYmpXYiWp5TiBwiYmGhViLCcYqcEFFBOfNa' + 'bJLLxyb74WZ9IWyyk9nfM79539kXMoT1oXdtWh8WKDGi6cJP4i+KI9aHgCIAjcoAQNWsD3eBDaCJ' + 'UHpMBLCtcBjYBq71hVW+hw9sXQEHhP1jgpJPGFiwreCd0QW3YFRQTXehnzNwwPrwCHiJcLpYDqgJ' + 'v2Xyqp1ZxPpwC9hCcS6LW7umAkiCIxMccEZjW+EVQj1xbm4HOiNikiEPhCiPeLEcALGtkG2OSq+c' + 'KBVx/AEn3ZIeLNdeDhwC5vKWanoSju674oL14Yf14VJv3PqwiuILcHBs5VIUQEaSsXeN7+8B7lkf' + '3gC/geWh/2RI2vQqENpDeJLo0vwY6Ki4sFXIAXdVf+YPexHuZypTSbBdWHZG14sdxfHoT2f0ZWAe' + 'xetEO1WiS3dQ1JzRt3tnRCGAgYnv3JI+hnAe+JYoGt97SsScM/p69yT519fxGMgDZ/Q+hJt9y+PP' + 'JkLTGX2KDhsAg6War8rT33QngPd0+EqEB144o1etD2eBZ87odokNSSLyRRSbRKw4o68AD60Pz4HH' + 'KI6W3BEllqd07b9hfdhG8QHF8f7YzAFU9+yIpWoJiThzB1aA9axHbfkA8NEZ3UA4A3zqg6iKAHZK' + 'Uq0B9aE+QapxoAvSBMXuodWrCgEyd0kzBSjYtpfrwHCzoqp3YAdinQ5vqwWAX0AbYdEZ3SDiO/8j' + 'pjUcafEXmhXMpGcNRP4AAAAASUVORK5CYII=)';
        marker.style.backgroundPosition = '50%';
        marker.style.backgroundSize = '70%';
        marker.style.backgroundAttachment = 'scroll';
        marker.style.backgroundRepeat = 'no-repeat';
        marker.style.display = _this.isOnTop(bounds.left + bounds.width - bounds.height / 2, bounds.top + bounds.height / 2, input) ? 'block' : 'none';
        marker.style.position = 'fixed';
        marker.style.zIndex = '2147483647';
        marker.style.top = bounds.top + 'px';
        marker.style.left = bounds.left + bounds.width - bounds.height + 'px';
        marker.style.width = bounds.height + 'px';
        marker.style.height = bounds.height + 'px';
        marker.style.minHeight = '16px';
        marker.style.minWidth = '16px';
        marker.style.cursor = 'pointer';
        markerObj.dead = false;
    };

    this.isOnTop = function (x, y, elem) {
        var elems = document.elementsFromPoint(x, y).filter(function (e) {
            return e.dataset.keyhubmarker !== 'true';
        });
        return elems[0] === elem;
    };

    this.triggerPopup = function (details) {
        var forms = _this.findLoginForms();
        var form = forms.find(function (f) {
            return f.usn.includes(document.activeElement) || f.pwd.includes(document.activeElement);
        });
        if (form === undefined) {
            form = forms.find(function (f) {
                return true;
            });
        }
        if (form === undefined && document.activeElement instanceof HTMLInputElement) {
            form = {
                score: 1,
                usn: [],
                pwd: []
            };
            if ((document.activeElement.type || '').toLowerCase() === 'password') {
                form.pwd.push(document.activeElement);
            } else {
                form.usn.push(document.activeElement);
            }
        }
        if (form !== undefined) {
            if (document.activeElement instanceof HTMLInputElement) {
                var bounds = document.activeElement.getBoundingClientRect();
                _this.moveElementToFront(form.usn, document.activeElement);
                _this.moveElementToFront(form.pwd, document.activeElement);
                _this.showContextPopup(form, document.activeElement, bounds);
            } else {
                var offset = _this._clickOffset;
                offset.left = Math.min(offset.left, window.innerWidth - 315);
                _this.showContextPopup(form, undefined, { top: offset.top, left: offset.left, width: 300, height: 0 });
            }
        }
    };

    this.moveElementToFront = function (arr, elem) {
        if (arr.includes(elem)) {
            arr.splice(arr.indexOf(elem), 1);
            arr.unshift(elem);
        }
    };

    this.showContextPopup = function (form, prio, bounds) {
        if (_this._contextPopup !== undefined) {
            _this._contextPopup.iframe.remove();
        }
        var iframe = document.createElement('iframe');
        iframe.id = 'keyhub-fill';
        document.body.appendChild(iframe);

        iframe.style.boxSizing = 'content-box';
        iframe.style.display = 'block';
        iframe.style.position = 'fixed';
        iframe.style.visibility = 'visible';
        iframe.style.zIndex = '2147483647';
        iframe.style.border = '2px solid #e9eaeb';
        iframe.style.margin = '0px';
        iframe.style.padding = '0px';
        iframe.style.opacity = '1';
        iframe.style.minWidth = '275px';
        iframe.style.height = '0px';
        _this.positionPopup(iframe, bounds);
        iframe.src = chrome.runtime.getURL('index.html?context=popup&url=' + encodeURI(window.location.href));
        _this._contextPopup = {
            iframe: iframe,
            form: form,
            prio: prio
        };
        _this.clearDOMObserver();
    };

    this.positionPopup = function (iframe, bounds) {
        var windowHeight = document.documentElement.clientHeight;
        var bottomSpace = windowHeight - bounds.top - bounds.height;
        iframe.style.width = bounds.width - 4 + 'px';
        iframe.style.left = bounds.left + 'px';
        if (bottomSpace > 200 || bottomSpace > bounds.top) {
            iframe.style.bottom = '';
            iframe.style.top = bounds.top + bounds.height + 'px';
            iframe.style.maxHeight = bottomSpace + 'px';
        } else {
            iframe.style.top = '';
            iframe.style.bottom = windowHeight - bounds.top + 'px';
            iframe.style.maxHeight = bounds.top + 'px';
        }
    };

    this._markers = [];
    chrome.runtime.sendMessage({
        type: 'record-count',
        url: window.location.href
    }, function (response) {
        if (response && response.count > 0) {
            _this.register();
        }
    });
    window.addEventListener('message', function (event) {
        var extURL = chrome.runtime.getURL('').slice(0, -1);
        if (_this._contextPopup !== undefined && event.origin === extURL) {
            if (event.data.type === 'resize') {
                _this.resizeIFrame(event.data.height);
            } else if (event.data.type === 'fill') {
                _this.fill(event.data.creds);
            }
        }
    });
    window.addEventListener('click', this.closeIFrame);
    window.addEventListener('mousedown', function (event) {
        if (event.button == 2) {
            _this._clickOffset = { left: event.clientX, top: event.clientY };
        }
    }, true);
    chrome.runtime.onMessage.addListener(function (request, sender) {
        if (sender.extensionId === chrome.runtime.id || sender.id === chrome.runtime.id) {
            if (request.type === 'fill') {
                _this.fill(request.creds);
            } else if (request.type === 'trigger-fill') {
                _this.triggerPopup(request);
            }
        }
    });
};

exports.default = KeyHubFill;

/***/ }),

/***/ 29:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/* eslint-env webextensions */

var KeyHubFill = function KeyHubFill() {
    var _this = this;

    _classCallCheck(this, KeyHubFill);

    this.register = function () {
        _this._observer = new MutationObserver(function (mutations) {
            _this.findAndMarkLoginForms();
        });
        _this._observer.observe(document, { childList: true, attributes: true, subtree: true });
        window.addEventListener('scroll', _this.findAndMarkLoginForms, { capture: true, passive: true });
        window.addEventListener('resize', _this.findAndMarkLoginForms);
        _this.findAndMarkLoginForms();
    };

    this.clearDOMObserver = function () {
        if (_this._observer !== undefined) {
            _this._observer.takeRecords();
        }
    };

    this.resizeIFrame = function (height) {
        _this._contextPopup.iframe.style.height = Math.min(400, height) + 'px';
        _this.clearDOMObserver();
    };

    this.closeIFrame = function (event) {
        if (_this._contextPopup !== undefined) {
            _this._contextPopup.iframe.remove();
            _this._contextPopup = undefined;
        }
    };

    this.fill = function (creds) {
        if (_this._contextPopup !== undefined) {
            var formToFill = _this._contextPopup.form;
            var prio = _this._contextPopup.prio;
            var fillPassword = formToFill.pwd.length > 0 && creds.password !== undefined;
            var fillTotp = formToFill.pwd.length === 0 && creds.totp !== undefined;
            var fillUsername = !fillTotp && creds.username !== undefined;
            if (fillUsername) {
                if (formToFill.usn.length === 1 && (!formToFill.usn[0].value || formToFill.usn[0] === prio)) {
                    _this.fillInput(formToFill.usn[0], creds.username);
                } else if (formToFill.usn.length > 1 && formToFill.usn[0] === prio) {
                    _this.fillInput(formToFill.usn[0], creds.username);
                }
            }
            if (fillPassword) {
                formToFill.pwd.filter(function (e, i) {
                    return i === 0;
                }).forEach(function (e) {
                    return _this.fillInput(e, creds.password);
                });
            }
            if (fillTotp) {
                formToFill.usn.filter(function (e, i) {
                    return i === 0;
                }).forEach(function (e) {
                    return _this.fillInput(e, creds.totp);
                });
            }
        }
        _this.closeIFrame();
    };

    this.fillInput = function (input, value) {
        input.value = value;
        input.dispatchEvent(new Event('change', { bubbles: true }));
        input.dispatchEvent(new Event('input', { bubbles: true }));
        input.dispatchEvent(new KeyboardEvent('keydown', { bubbles: true }));
        input.dispatchEvent(new KeyboardEvent('keyup', { bubbles: true }));
    };

    this.findLoginForms = function () {
        return Array.prototype.slice.call(document.querySelectorAll('form')).map(_this.scoreForm).filter(function (form) {
            return form.usn.length > 0 || form.pwd.length > 0;
        }).sort(function (a, b) {
            return b.score - a.score;
        });
    };

    this.findAndMarkLoginForms = function () {
        var forms = _this.findLoginForms().reduce(function (acc, val) {
            if (acc.length === 0 || val.score >= 4 || val.score === acc[0].score) {
                acc.push(val);
            }
            return acc;
        }, []);
        _this._markers.forEach(function (marker) {
            return marker.dead = true;
        });
        forms.filter(function (form) {
            return form.score > 2;
        }).forEach(function (form) {
            form.usn.forEach(function (input) {
                return _this.markInput(form, input);
            });
            form.pwd.forEach(function (input) {
                return _this.markInput(form, input);
            });
        });
        if (_this._contextPopup !== undefined && _this._contextPopup.prio !== undefined) {
            var bounds = _this._contextPopup.prio.getBoundingClientRect();
            _this.positionPopup(_this._contextPopup.iframe, bounds);
        }
        _this.removeAllDeadMarkers();
        _this.clearDOMObserver();
    };

    this.removeAllDeadMarkers = function () {
        _this._markers.filter(function (marker) {
            return marker.dead;
        }).forEach(function (marker) {
            return marker.marker.remove();
        });
        _this._markers = _this._markers.filter(function (marker) {
            return !marker.dead;
        });
    };

    this.scoreForm = function (form) {
        var USERNAME = ['input[type=email]', 'input[type=text]', 'input:not([type])'].join(',');
        var PASSWORD = 'input:not([autocomplete=new-password])[type=password]';
        var usernameFields = Array.prototype.slice.call(form.querySelectorAll(USERNAME)).filter(_this.isVisible);
        var passwordFields = Array.prototype.slice.call(form.querySelectorAll(PASSWORD)).filter(_this.isVisible);
        var ret = {
            form: form,
            usn: usernameFields,
            pwd: passwordFields
        };

        if (passwordFields.length === 0 && usernameFields.length === 0) {
            ret.score = 0;
        } else if (usernameFields.some(function (usn) {
            return usn.getAttribute('autocomplete') === 'username';
        }) || passwordFields.some(function (pwd) {
            return pwd.getAttribute('autocomplete') === 'current-password';
        })) {
            ret.score = 5;
        } else if (passwordFields.length === 1 && usernameFields.length === 1) {
            ret.score = 4;
        } else if (passwordFields.length === 1 && usernameFields.length === 0) {
            ret.score = 3;
        } else if (passwordFields.length === 1 && usernameFields.length > 1) {
            ret.score = 2;
        } else if (passwordFields.length === 0 && usernameFields.length === 1) {
            ret.score = 1;
        } else {
            ret.score = 0;
        }
        return ret;
    };

    this.isVisible = function (elem) {
        return !!(elem.offsetWidth || elem.offsetHeight || elem.getClientRects().length);
    };

    this.markInput = function (form, input) {
        var markerObj = _this._markers.find(function (m) {
            return m.input === input;
        });
        if (markerObj === undefined) {
            markerObj = {
                form: form,
                input: input,
                marker: document.createElement('div')
            };
            document.body.appendChild(markerObj.marker);
            markerObj.marker.addEventListener('click', function (event) {
                event.stopPropagation();
                _this.showContextPopup(form, input, input.getBoundingClientRect());
            });
            _this._markers.push(markerObj);
        }
        var marker = markerObj.marker;
        var bounds = input.getBoundingClientRect();
        marker.dataset.keyhubmarker = 'true';
        marker.dataset.anchor = input.name;
        marker.style.backgroundImage = 'url(data:image/png;base64,' + 'iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAYAAABzenr0AAAABmJLR0QA/wD/AP+gvaeTAAAACXBI' + 'WXMAAAsTAAALEwEAmpwYAAAAB3RJTUUH4QUeDCAaCBbp5wAAAlNJREFUWMPFlr2LE0EYh5/ZiIUW' + '4lcjVwtXSbhCMKBkTiutRETB5kYGQTj/Av8Bue4QFAYmpXYiWp5TiBwiYmGhViLCcYqcEFFBOfNa' + 'bJLLxyb74WZ9IWyyk9nfM79539kXMoT1oXdtWh8WKDGi6cJP4i+KI9aHgCIAjcoAQNWsD3eBDaCJ' + 'UHpMBLCtcBjYBq71hVW+hw9sXQEHhP1jgpJPGFiwreCd0QW3YFRQTXehnzNwwPrwCHiJcLpYDqgJ' + 'v2Xyqp1ZxPpwC9hCcS6LW7umAkiCIxMccEZjW+EVQj1xbm4HOiNikiEPhCiPeLEcALGtkG2OSq+c' + 'KBVx/AEn3ZIeLNdeDhwC5vKWanoSju674oL14Yf14VJv3PqwiuILcHBs5VIUQEaSsXeN7+8B7lkf' + '3gC/geWh/2RI2vQqENpDeJLo0vwY6Ki4sFXIAXdVf+YPexHuZypTSbBdWHZG14sdxfHoT2f0ZWAe' + 'xetEO1WiS3dQ1JzRt3tnRCGAgYnv3JI+hnAe+JYoGt97SsScM/p69yT519fxGMgDZ/Q+hJt9y+PP' + 'JkLTGX2KDhsAg6War8rT33QngPd0+EqEB144o1etD2eBZ87odokNSSLyRRSbRKw4o68AD60Pz4HH' + 'KI6W3BEllqd07b9hfdhG8QHF8f7YzAFU9+yIpWoJiThzB1aA9axHbfkA8NEZ3UA4A3zqg6iKAHZK' + 'Uq0B9aE+QapxoAvSBMXuodWrCgEyd0kzBSjYtpfrwHCzoqp3YAdinQ5vqwWAX0AbYdEZ3SDiO/8j' + 'pjUcafEXmhXMpGcNRP4AAAAASUVORK5CYII=)';
        marker.style.backgroundPosition = '50%';
        marker.style.backgroundSize = '70%';
        marker.style.backgroundAttachment = 'scroll';
        marker.style.backgroundRepeat = 'no-repeat';
        marker.style.display = _this.isOnTop(bounds.left + bounds.width - bounds.height / 2, bounds.top + bounds.height / 2, input) ? 'block' : 'none';
        marker.style.position = 'fixed';
        marker.style.zIndex = '2147483647';
        marker.style.top = bounds.top + 'px';
        marker.style.left = bounds.left + bounds.width - bounds.height + 'px';
        marker.style.width = bounds.height + 'px';
        marker.style.height = bounds.height + 'px';
        marker.style.minHeight = '16px';
        marker.style.minWidth = '16px';
        marker.style.cursor = 'pointer';
        markerObj.dead = false;
    };

    this.isOnTop = function (x, y, elem) {
        var elems = document.elementsFromPoint(x, y).filter(function (e) {
            return e.dataset.keyhubmarker !== 'true';
        });
        return elems[0] === elem;
    };

    this.triggerPopup = function (details) {
        var forms = _this.findLoginForms();
        var form = forms.find(function (f) {
            return f.usn.includes(document.activeElement) || f.pwd.includes(document.activeElement);
        });
        if (form === undefined) {
            form = forms.find(function (f) {
                return true;
            });
        }
        if (form === undefined && document.activeElement instanceof HTMLInputElement) {
            form = {
                score: 1,
                usn: [],
                pwd: []
            };
            if ((document.activeElement.type || '').toLowerCase() === 'password') {
                form.pwd.push(document.activeElement);
            } else {
                form.usn.push(document.activeElement);
            }
        }
        if (form !== undefined) {
            if (document.activeElement instanceof HTMLInputElement) {
                var bounds = document.activeElement.getBoundingClientRect();
                _this.moveElementToFront(form.usn, document.activeElement);
                _this.moveElementToFront(form.pwd, document.activeElement);
                _this.showContextPopup(form, document.activeElement, bounds);
            } else {
                var offset = _this._clickOffset;
                offset.left = Math.min(offset.left, window.innerWidth - 315);
                _this.showContextPopup(form, undefined, { top: offset.top, left: offset.left, width: 300, height: 0 });
            }
        }
    };

    this.moveElementToFront = function (arr, elem) {
        if (arr.includes(elem)) {
            arr.splice(arr.indexOf(elem), 1);
            arr.unshift(elem);
        }
    };

    this.showContextPopup = function (form, prio, bounds) {
        if (_this._contextPopup !== undefined) {
            _this._contextPopup.iframe.remove();
        }
        var iframe = document.createElement('iframe');
        iframe.id = 'keyhub-fill';
        document.body.appendChild(iframe);

        iframe.style.boxSizing = 'content-box';
        iframe.style.display = 'block';
        iframe.style.position = 'fixed';
        iframe.style.visibility = 'visible';
        iframe.style.zIndex = '2147483647';
        iframe.style.border = '2px solid #e9eaeb';
        iframe.style.margin = '0px';
        iframe.style.padding = '0px';
        iframe.style.opacity = '1';
        iframe.style.minWidth = '275px';
        iframe.style.height = '0px';
        _this.positionPopup(iframe, bounds);
        iframe.src = chrome.runtime.getURL('index.html?context=popup&url=' + encodeURI(window.location.href));
        _this._contextPopup = {
            iframe: iframe,
            form: form,
            prio: prio
        };
        _this.clearDOMObserver();
    };

    this.positionPopup = function (iframe, bounds) {
        var windowHeight = document.documentElement.clientHeight;
        var bottomSpace = windowHeight - bounds.top - bounds.height;
        iframe.style.width = bounds.width - 4 + 'px';
        iframe.style.left = bounds.left + 'px';
        if (bottomSpace > 200 || bottomSpace > bounds.top) {
            iframe.style.bottom = '';
            iframe.style.top = bounds.top + bounds.height + 'px';
            iframe.style.maxHeight = bottomSpace + 'px';
        } else {
            iframe.style.top = '';
            iframe.style.bottom = windowHeight - bounds.top + 'px';
            iframe.style.maxHeight = bounds.top + 'px';
        }
    };

    this._markers = [];
    chrome.runtime.sendMessage({
        type: 'record-count',
        url: window.location.href
    }, function (response) {
        if (response && response.count > 0) {
            _this.register();
        }
    });
    window.addEventListener('message', function (event) {
        var extURL = chrome.runtime.getURL('').slice(0, -1);
        if (_this._contextPopup !== undefined && event.origin === extURL) {
            if (event.data.type === 'resize') {
                _this.resizeIFrame(event.data.height);
            } else if (event.data.type === 'fill') {
                _this.fill(event.data.creds);
            }
        }
    });
    window.addEventListener('click', this.closeIFrame);
    window.addEventListener('mousedown', function (event) {
        if (event.button == 2) {
            _this._clickOffset = { left: event.clientX, top: event.clientY };
        }
    }, true);
    chrome.runtime.onMessage.addListener(function (request, sender) {
        if (sender.extensionId === chrome.runtime.id || sender.id === chrome.runtime.id) {
            if (request.type === 'fill') {
                _this.fill(request.creds);
            } else if (request.type === 'trigger-fill') {
                _this.triggerPopup(request);
            }
        }
    });
};

exports.default = KeyHubFill;

/***/ })

/******/ });